# API Reference <a name="API Reference" id="api-reference"></a>


## Structs <a name="Structs" id="Structs"></a>

### DiagramOptions <a name="DiagramOptions" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramOptions"></a>

Options for diagrams.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramOptions.Initializer"></a>

```java
import software.aws.awsprototypingsdk.cdkgraphplugindiagram.DiagramOptions;

DiagramOptions.builder()
    .title(java.lang.String)
//  .preset(FilterPreset)
//  .theme(IGraphThemeConfigAlt)
//  .theme(java.lang.String)
    .build();
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramOptions.property.title">title</a></code> | <code>java.lang.String</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramOptions.property.preset">preset</a></code> | <code>software.aws.awsprototypingsdk.cdkgraph.FilterPreset</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramOptions.property.theme">theme</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeConfigAlt">IGraphThemeConfigAlt</a> OR java.lang.String</code> | *No description.* |

---

##### `title`<sup>Required</sup> <a name="title" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramOptions.property.title"></a>

```java
public java.lang.String getTitle();
```

- *Type:* java.lang.String

---

##### `preset`<sup>Optional</sup> <a name="preset" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramOptions.property.preset"></a>

```java
public FilterPreset getPreset();
```

- *Type:* software.aws.awsprototypingsdk.cdkgraph.FilterPreset

---

##### `theme`<sup>Optional</sup> <a name="theme" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramOptions.property.theme"></a>

```java
public java.lang.Object getTheme();
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeConfigAlt">IGraphThemeConfigAlt</a> OR java.lang.String

---

### IDiagramConfig <a name="IDiagramConfig" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig"></a>

Diagram configuration definition.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.Initializer"></a>

```java
import software.aws.awsprototypingsdk.cdkgraphplugindiagram.IDiagramConfig;

IDiagramConfig.builder()
//  .filterPlan(IGraphFilterPlan)
//  .format(DiagramFormat)
//  .format(java.util.List<DiagramFormat>)
//  .theme(IGraphThemeConfigAlt)
//  .theme(java.lang.String)
    .name(java.lang.String)
    .title(java.lang.String)
//  .ignoreDefaults(java.lang.Boolean)
    .build();
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.property.filterPlan">filterPlan</a></code> | <code>software.aws.awsprototypingsdk.cdkgraph.IGraphFilterPlan</code> | Graph {@link IGraphFilterPlanFilter Plan}  used to generate a unique diagram. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.property.format">format</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat">DiagramFormat</a> OR java.util.List<<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat">DiagramFormat</a>></code> | The output format(s) to generated. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.property.theme">theme</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeConfigAlt">IGraphThemeConfigAlt</a> OR java.lang.String</code> | Config for graph theme. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.property.name">name</a></code> | <code>java.lang.String</code> | Name of the diagram. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.property.title">title</a></code> | <code>java.lang.String</code> | The title of the diagram. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.property.ignoreDefaults">ignoreDefaults</a></code> | <code>java.lang.Boolean</code> | Indicates if default diagram config is applied as defaults to this config. |

---

##### `filterPlan`<sup>Optional</sup> <a name="filterPlan" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.property.filterPlan"></a>

```java
public IGraphFilterPlan getFilterPlan();
```

- *Type:* software.aws.awsprototypingsdk.cdkgraph.IGraphFilterPlan

Graph {@link IGraphFilterPlanFilter Plan}  used to generate a unique diagram.

---

##### `format`<sup>Optional</sup> <a name="format" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.property.format"></a>

```java
public java.lang.Object getFormat();
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat">DiagramFormat</a> OR java.util.List<<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat">DiagramFormat</a>>
- *Default:* `DiagramFormat.PNG` - which will through extension also generate `DiagramFormat.SVG` and `DiagramFormat.DOT`

The output format(s) to generated.

---

##### `theme`<sup>Optional</sup> <a name="theme" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.property.theme"></a>

```java
public java.lang.Object getTheme();
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeConfigAlt">IGraphThemeConfigAlt</a> OR java.lang.String

Config for graph theme.

---

##### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.property.name"></a>

```java
public java.lang.String getName();
```

- *Type:* java.lang.String

Name of the diagram.

Used as the basename of the generated file(s) which gets the extension appended.

---

##### `title`<sup>Required</sup> <a name="title" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.property.title"></a>

```java
public java.lang.String getTitle();
```

- *Type:* java.lang.String

The title of the diagram.

---

##### `ignoreDefaults`<sup>Optional</sup> <a name="ignoreDefaults" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.property.ignoreDefaults"></a>

```java
public java.lang.Boolean getIgnoreDefaults();
```

- *Type:* java.lang.Boolean
- *Default:* false

Indicates if default diagram config is applied as defaults to this config.

---

### IDiagramConfigBase <a name="IDiagramConfigBase" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfigBase"></a>

Base config to specific a unique diagram to be generated.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfigBase.Initializer"></a>

```java
import software.aws.awsprototypingsdk.cdkgraphplugindiagram.IDiagramConfigBase;

IDiagramConfigBase.builder()
//  .filterPlan(IGraphFilterPlan)
//  .format(DiagramFormat)
//  .format(java.util.List<DiagramFormat>)
//  .theme(IGraphThemeConfigAlt)
//  .theme(java.lang.String)
    .build();
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfigBase.property.filterPlan">filterPlan</a></code> | <code>software.aws.awsprototypingsdk.cdkgraph.IGraphFilterPlan</code> | Graph {@link IGraphFilterPlanFilter Plan}  used to generate a unique diagram. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfigBase.property.format">format</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat">DiagramFormat</a> OR java.util.List<<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat">DiagramFormat</a>></code> | The output format(s) to generated. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfigBase.property.theme">theme</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeConfigAlt">IGraphThemeConfigAlt</a> OR java.lang.String</code> | Config for graph theme. |

---

##### `filterPlan`<sup>Optional</sup> <a name="filterPlan" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfigBase.property.filterPlan"></a>

```java
public IGraphFilterPlan getFilterPlan();
```

- *Type:* software.aws.awsprototypingsdk.cdkgraph.IGraphFilterPlan

Graph {@link IGraphFilterPlanFilter Plan}  used to generate a unique diagram.

---

##### `format`<sup>Optional</sup> <a name="format" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfigBase.property.format"></a>

```java
public java.lang.Object getFormat();
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat">DiagramFormat</a> OR java.util.List<<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat">DiagramFormat</a>>
- *Default:* `DiagramFormat.PNG` - which will through extension also generate `DiagramFormat.SVG` and `DiagramFormat.DOT`

The output format(s) to generated.

---

##### `theme`<sup>Optional</sup> <a name="theme" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfigBase.property.theme"></a>

```java
public java.lang.Object getTheme();
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeConfigAlt">IGraphThemeConfigAlt</a> OR java.lang.String

Config for graph theme.

---

### IPluginConfig <a name="IPluginConfig" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IPluginConfig"></a>

Plugin configuration for diagram plugin.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IPluginConfig.Initializer"></a>

```java
import software.aws.awsprototypingsdk.cdkgraphplugindiagram.IPluginConfig;

IPluginConfig.builder()
//  .defaults(IDiagramConfigBase)
//  .diagrams(java.util.List<IDiagramConfig>)
    .build();
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IPluginConfig.property.defaults">defaults</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfigBase">IDiagramConfigBase</a></code> | Default configuration to apply to all diagrams. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IPluginConfig.property.diagrams">diagrams</a></code> | <code>java.util.List<<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig">IDiagramConfig</a>></code> | List of diagram configurations to generate diagrams. |

---

##### `defaults`<sup>Optional</sup> <a name="defaults" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IPluginConfig.property.defaults"></a>

```java
public IDiagramConfigBase getDefaults();
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfigBase">IDiagramConfigBase</a>

Default configuration to apply to all diagrams.

---

##### `diagrams`<sup>Optional</sup> <a name="diagrams" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IPluginConfig.property.diagrams"></a>

```java
public java.util.List<IDiagramConfig> getDiagrams();
```

- *Type:* java.util.List<<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig">IDiagramConfig</a>>

List of diagram configurations to generate diagrams.

---

## Classes <a name="Classes" id="Classes"></a>

### CdkGraphDiagramPlugin <a name="CdkGraphDiagramPlugin" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin"></a>

- *Implements:* software.aws.awsprototypingsdk.cdkgraph.ICdkGraphPlugin

CdkGraphDiagramPlugin is a {@link ICdkGraphPluginCdkGraph Plugin} implementation for generating diagram artifacts from the {@link CdkGraph} framework.

#### Initializers <a name="Initializers" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.Initializer"></a>

```java
import software.aws.awsprototypingsdk.cdkgraphplugindiagram.CdkGraphDiagramPlugin;

CdkGraphDiagramPlugin.Builder.create()
//  .defaults(IDiagramConfigBase)
//  .diagrams(java.util.List<IDiagramConfig>)
    .build();
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.Initializer.parameter.defaults">defaults</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfigBase">IDiagramConfigBase</a></code> | Default configuration to apply to all diagrams. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.Initializer.parameter.diagrams">diagrams</a></code> | <code>java.util.List<<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig">IDiagramConfig</a>></code> | List of diagram configurations to generate diagrams. |

---

##### `defaults`<sup>Optional</sup> <a name="defaults" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.Initializer.parameter.defaults"></a>

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfigBase">IDiagramConfigBase</a>

Default configuration to apply to all diagrams.

---

##### `diagrams`<sup>Optional</sup> <a name="diagrams" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.Initializer.parameter.diagrams"></a>

- *Type:* java.util.List<<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig">IDiagramConfig</a>>

List of diagram configurations to generate diagrams.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.getDiagramArtifact">getDiagramArtifact</a></code> | Get diagram artifact for a given name and format. |

---

##### `getDiagramArtifact` <a name="getDiagramArtifact" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.getDiagramArtifact"></a>

```java
public CdkGraphArtifact getDiagramArtifact(java.lang.String name, DiagramFormat format)
```

Get diagram artifact for a given name and format.

###### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.getDiagramArtifact.parameter.name"></a>

- *Type:* java.lang.String

---

###### `format`<sup>Required</sup> <a name="format" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.getDiagramArtifact.parameter.format"></a>

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat">DiagramFormat</a>

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.artifactFilename">artifactFilename</a></code> | Get standardized artifact file name for diagram artifacts. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.artifactId">artifactId</a></code> | Get standardized artifact id for diagram artifacts. |

---

##### `artifactFilename` <a name="artifactFilename" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.artifactFilename"></a>

```java
import software.aws.awsprototypingsdk.cdkgraphplugindiagram.CdkGraphDiagramPlugin;

CdkGraphDiagramPlugin.artifactFilename(java.lang.String name, DiagramFormat format)
```

Get standardized artifact file name for diagram artifacts.

###### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.artifactFilename.parameter.name"></a>

- *Type:* java.lang.String

---

###### `format`<sup>Required</sup> <a name="format" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.artifactFilename.parameter.format"></a>

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat">DiagramFormat</a>

---

##### `artifactId` <a name="artifactId" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.artifactId"></a>

```java
import software.aws.awsprototypingsdk.cdkgraphplugindiagram.CdkGraphDiagramPlugin;

CdkGraphDiagramPlugin.artifactId(java.lang.String name, DiagramFormat format)
```

Get standardized artifact id for diagram artifacts.

###### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.artifactId.parameter.name"></a>

- *Type:* java.lang.String

---

###### `format`<sup>Required</sup> <a name="format" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.artifactId.parameter.format"></a>

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat">DiagramFormat</a>

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.config">config</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IPluginConfig">IPluginConfig</a></code> | Get diagram plugin config. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.id">id</a></code> | <code>java.lang.String</code> | Unique identifier for this plugin. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.version">version</a></code> | <code>java.lang.String</code> | Plugin version. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.defaultDotArtifact">defaultDotArtifact</a></code> | <code>software.aws.awsprototypingsdk.cdkgraph.CdkGraphArtifact</code> | Get default dot artifact. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.defaultPngArtifact">defaultPngArtifact</a></code> | <code>software.aws.awsprototypingsdk.cdkgraph.CdkGraphArtifact</code> | Get default PNG artifact. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.dependencies">dependencies</a></code> | <code>java.util.List<java.lang.String></code> | List of plugins this plugin depends on, including optional semver version (eg: ["foo", "bar@1.2"]). |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.bind">bind</a></code> | <code>software.aws.awsprototypingsdk.cdkgraph.IGraphPluginBindCallback</code> | Binds the plugin to the CdkGraph instance. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.report">report</a></code> | <code>software.aws.awsprototypingsdk.cdkgraph.IGraphReportCallback</code> | Generate asynchronous reports based on the graph. |

---

##### `config`<sup>Required</sup> <a name="config" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.config"></a>

```java
public IPluginConfig getConfig();
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IPluginConfig">IPluginConfig</a>

Get diagram plugin config.

---

##### `id`<sup>Required</sup> <a name="id" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.id"></a>

```java
public java.lang.String getId();
```

- *Type:* java.lang.String

Unique identifier for this plugin.

---

##### `version`<sup>Required</sup> <a name="version" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.version"></a>

```java
public java.lang.String getVersion();
```

- *Type:* java.lang.String

Plugin version.

---

##### `defaultDotArtifact`<sup>Optional</sup> <a name="defaultDotArtifact" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.defaultDotArtifact"></a>

```java
public CdkGraphArtifact getDefaultDotArtifact();
```

- *Type:* software.aws.awsprototypingsdk.cdkgraph.CdkGraphArtifact

Get default dot artifact.

---

##### `defaultPngArtifact`<sup>Optional</sup> <a name="defaultPngArtifact" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.defaultPngArtifact"></a>

```java
public CdkGraphArtifact getDefaultPngArtifact();
```

- *Type:* software.aws.awsprototypingsdk.cdkgraph.CdkGraphArtifact

Get default PNG artifact.

---

##### `dependencies`<sup>Optional</sup> <a name="dependencies" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.dependencies"></a>

```java
public java.util.List<java.lang.String> getDependencies();
```

- *Type:* java.util.List<java.lang.String>

List of plugins this plugin depends on, including optional semver version (eg: ["foo", "bar@1.2"]).

---

##### `bind`<sup>Required</sup> <a name="bind" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.bind"></a>

```java
public IGraphPluginBindCallback getBind();
```

- *Type:* software.aws.awsprototypingsdk.cdkgraph.IGraphPluginBindCallback

Binds the plugin to the CdkGraph instance.

Enables plugins to receive base configs.

---

##### `report`<sup>Optional</sup> <a name="report" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.report"></a>

```java
public IGraphReportCallback getReport();
```

- *Type:* software.aws.awsprototypingsdk.cdkgraph.IGraphReportCallback

Generate asynchronous reports based on the graph.

This is not automatically called when synthesizing CDK.
Developer must explicitly add `await graphInstance.report()` to the CDK bin or invoke this outside
of the CDK synth. In either case, the plugin receives the in-memory graph interface when invoked, as the
CdkGraph will deserialize the graph prior to invoking the plugin report.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.ARTIFACT_NS">ARTIFACT_NS</a></code> | <code>java.lang.String</code> | Namespace for artifacts of the diagram plugin. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.ID">ID</a></code> | <code>java.lang.String</code> | Fixed id of the diagram plugin. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.VERSION">VERSION</a></code> | <code>java.lang.String</code> | Current semantic version of the diagram plugin. |

---

##### `ARTIFACT_NS`<sup>Required</sup> <a name="ARTIFACT_NS" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.ARTIFACT_NS"></a>

```java
public java.lang.String getArtifactNs();
```

- *Type:* java.lang.String

Namespace for artifacts of the diagram plugin.

---

##### `ID`<sup>Required</sup> <a name="ID" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.ID"></a>

```java
public java.lang.String getId();
```

- *Type:* java.lang.String

Fixed id of the diagram plugin.

---

##### `VERSION`<sup>Required</sup> <a name="VERSION" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.VERSION"></a>

```java
public java.lang.String getVersion();
```

- *Type:* java.lang.String

Current semantic version of the diagram plugin.

---

## Protocols <a name="Protocols" id="Protocols"></a>

### IGraphThemeConfigAlt <a name="IGraphThemeConfigAlt" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeConfigAlt"></a>

- *Implemented By:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeConfigAlt">IGraphThemeConfigAlt</a>

GraphThemeConfigAlt is simplified definition of theme to apply.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeConfigAlt.property.rendering">rendering</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering">IGraphThemeRendering</a></code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeConfigAlt.property.theme">theme</a></code> | <code>java.lang.String</code> | *No description.* |

---

##### `rendering`<sup>Optional</sup> <a name="rendering" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeConfigAlt.property.rendering"></a>

```java
public IGraphThemeRendering getRendering();
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering">IGraphThemeRendering</a>

---

##### `theme`<sup>Optional</sup> <a name="theme" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeConfigAlt.property.theme"></a>

```java
public java.lang.String getTheme();
```

- *Type:* java.lang.String

---

### IGraphThemeRendering <a name="IGraphThemeRendering" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering"></a>

- *Extends:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingIconProps">IGraphThemeRenderingIconProps</a>, <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingOptions">IGraphThemeRenderingOptions</a>

- *Implemented By:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering">IGraphThemeRendering</a>

Properties for defining the rendering options for the graph theme.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.cfnResourceIconMax">cfnResourceIconMax</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a></code> | Highest Graph.CfnResourceNode icon to render. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.cfnResourceIconMin">cfnResourceIconMin</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a></code> | Lowest Graph.CfnResourceNode icon to render. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.resourceIconMax">resourceIconMax</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a></code> | Highest Graph.ResourceNode icon to render. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.resourceIconMin">resourceIconMin</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a></code> | Lowest Graph.ResourceNode icon to render. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.layout">layout</a></code> | <code>java.lang.String</code> | Layout direction of the graph. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.stack">stack</a></code> | <code>java.lang.String</code> | Specify regex pattern to match root stacks to render. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.stage">stage</a></code> | <code>java.lang.String</code> | Specify which stage to render when multiple stages are available. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.unconstrainedCrossClusterEdges">unconstrainedCrossClusterEdges</a></code> | <code>java.lang.Boolean</code> | Prevent cross-cluster edges from ranking nodes in layout. |

---

##### `cfnResourceIconMax`<sup>Optional</sup> <a name="cfnResourceIconMax" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.cfnResourceIconMax"></a>

```java
public GraphThemeRenderingIconTarget getCfnResourceIconMax();
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a>

Highest Graph.CfnResourceNode icon to render.

---

##### `cfnResourceIconMin`<sup>Optional</sup> <a name="cfnResourceIconMin" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.cfnResourceIconMin"></a>

```java
public GraphThemeRenderingIconTarget getCfnResourceIconMin();
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a>

Lowest Graph.CfnResourceNode icon to render.

---

##### `resourceIconMax`<sup>Optional</sup> <a name="resourceIconMax" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.resourceIconMax"></a>

```java
public GraphThemeRenderingIconTarget getResourceIconMax();
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a>

Highest Graph.ResourceNode icon to render.

---

##### `resourceIconMin`<sup>Optional</sup> <a name="resourceIconMin" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.resourceIconMin"></a>

```java
public GraphThemeRenderingIconTarget getResourceIconMin();
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a>

Lowest Graph.ResourceNode icon to render.

---

##### `layout`<sup>Optional</sup> <a name="layout" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.layout"></a>

```java
public java.lang.String getLayout();
```

- *Type:* java.lang.String
- *Default:* horizontal

Layout direction of the graph.

---

##### `stack`<sup>Optional</sup> <a name="stack" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.stack"></a>

```java
public java.lang.String getStack();
```

- *Type:* java.lang.String
- *Default:* undefined Will render all stacks

Specify regex pattern to match root stacks to render.

---

##### `stage`<sup>Optional</sup> <a name="stage" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.stage"></a>

```java
public java.lang.String getStage();
```

- *Type:* java.lang.String
- *Default:* last

Specify which stage to render when multiple stages are available.

Can be a preset value of "first", "last", and "all", or regex string of the stage(s) to render.

---

##### `unconstrainedCrossClusterEdges`<sup>Optional</sup> <a name="unconstrainedCrossClusterEdges" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.unconstrainedCrossClusterEdges"></a>

```java
public java.lang.Boolean getUnconstrainedCrossClusterEdges();
```

- *Type:* java.lang.Boolean
- *Default:* false

Prevent cross-cluster edges from ranking nodes in layout.

> [https://graphviz.org/docs/attrs/constraint/](https://graphviz.org/docs/attrs/constraint/)

---

### IGraphThemeRenderingIconProps <a name="IGraphThemeRenderingIconProps" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingIconProps"></a>

- *Implemented By:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering">IGraphThemeRendering</a>, <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingIconProps">IGraphThemeRenderingIconProps</a>

Icon specific properties for configuring graph rendering of resource icons.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingIconProps.property.cfnResourceIconMax">cfnResourceIconMax</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a></code> | Highest Graph.CfnResourceNode icon to render. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingIconProps.property.cfnResourceIconMin">cfnResourceIconMin</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a></code> | Lowest Graph.CfnResourceNode icon to render. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingIconProps.property.resourceIconMax">resourceIconMax</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a></code> | Highest Graph.ResourceNode icon to render. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingIconProps.property.resourceIconMin">resourceIconMin</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a></code> | Lowest Graph.ResourceNode icon to render. |

---

##### `cfnResourceIconMax`<sup>Optional</sup> <a name="cfnResourceIconMax" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingIconProps.property.cfnResourceIconMax"></a>

```java
public GraphThemeRenderingIconTarget getCfnResourceIconMax();
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a>

Highest Graph.CfnResourceNode icon to render.

---

##### `cfnResourceIconMin`<sup>Optional</sup> <a name="cfnResourceIconMin" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingIconProps.property.cfnResourceIconMin"></a>

```java
public GraphThemeRenderingIconTarget getCfnResourceIconMin();
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a>

Lowest Graph.CfnResourceNode icon to render.

---

##### `resourceIconMax`<sup>Optional</sup> <a name="resourceIconMax" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingIconProps.property.resourceIconMax"></a>

```java
public GraphThemeRenderingIconTarget getResourceIconMax();
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a>

Highest Graph.ResourceNode icon to render.

---

##### `resourceIconMin`<sup>Optional</sup> <a name="resourceIconMin" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingIconProps.property.resourceIconMin"></a>

```java
public GraphThemeRenderingIconTarget getResourceIconMin();
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a>

Lowest Graph.ResourceNode icon to render.

---

### IGraphThemeRenderingOptions <a name="IGraphThemeRenderingOptions" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingOptions"></a>

- *Implemented By:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering">IGraphThemeRendering</a>, <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingOptions">IGraphThemeRenderingOptions</a>

Additional graph rendering options.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingOptions.property.layout">layout</a></code> | <code>java.lang.String</code> | Layout direction of the graph. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingOptions.property.stack">stack</a></code> | <code>java.lang.String</code> | Specify regex pattern to match root stacks to render. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingOptions.property.stage">stage</a></code> | <code>java.lang.String</code> | Specify which stage to render when multiple stages are available. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingOptions.property.unconstrainedCrossClusterEdges">unconstrainedCrossClusterEdges</a></code> | <code>java.lang.Boolean</code> | Prevent cross-cluster edges from ranking nodes in layout. |

---

##### `layout`<sup>Optional</sup> <a name="layout" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingOptions.property.layout"></a>

```java
public java.lang.String getLayout();
```

- *Type:* java.lang.String
- *Default:* horizontal

Layout direction of the graph.

---

##### `stack`<sup>Optional</sup> <a name="stack" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingOptions.property.stack"></a>

```java
public java.lang.String getStack();
```

- *Type:* java.lang.String
- *Default:* undefined Will render all stacks

Specify regex pattern to match root stacks to render.

---

##### `stage`<sup>Optional</sup> <a name="stage" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingOptions.property.stage"></a>

```java
public java.lang.String getStage();
```

- *Type:* java.lang.String
- *Default:* last

Specify which stage to render when multiple stages are available.

Can be a preset value of "first", "last", and "all", or regex string of the stage(s) to render.

---

##### `unconstrainedCrossClusterEdges`<sup>Optional</sup> <a name="unconstrainedCrossClusterEdges" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingOptions.property.unconstrainedCrossClusterEdges"></a>

```java
public java.lang.Boolean getUnconstrainedCrossClusterEdges();
```

- *Type:* java.lang.Boolean
- *Default:* false

Prevent cross-cluster edges from ranking nodes in layout.

> [https://graphviz.org/docs/attrs/constraint/](https://graphviz.org/docs/attrs/constraint/)

---

## Enums <a name="Enums" id="Enums"></a>

### DiagramFormat <a name="DiagramFormat" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat"></a>

Supported diagram formats that can be generated.

Extended formats are automatically generated, for example if you generate "png" which extends
"svg" which extends "dot", the resulting generated files will be all aforementioned.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat.DOT">DOT</a></code> | Graphviz [DOT Language](https://graphviz.org/doc/info/lang.html). |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat.SVG">SVG</a></code> | [SVG](https://developer.mozilla.org/en-US/docs/Web/SVG) generated using [dot-wasm](https://hpcc-systems.github.io/hpcc-js-wasm/classes/graphviz.Graphviz.html) from {@link DiagramFormat.DOT} file. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat.PNG">PNG</a></code> | [PNG](https://en.wikipedia.org/wiki/Portable_Network_Graphics) generated using [sharp](https://sharp.pixelplumbing.com/api-output#png) from {@link DiagramFormat.SVG} file. |

---

##### `DOT` <a name="DOT" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat.DOT"></a>

Graphviz [DOT Language](https://graphviz.org/doc/info/lang.html).

---


##### `SVG` <a name="SVG" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat.SVG"></a>

[SVG](https://developer.mozilla.org/en-US/docs/Web/SVG) generated using [dot-wasm](https://hpcc-systems.github.io/hpcc-js-wasm/classes/graphviz.Graphviz.html) from {@link DiagramFormat.DOT} file.

---


##### `PNG` <a name="PNG" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat.PNG"></a>

[PNG](https://en.wikipedia.org/wiki/Portable_Network_Graphics) generated using [sharp](https://sharp.pixelplumbing.com/api-output#png) from {@link DiagramFormat.SVG} file.

---


### GraphThemeRenderingIconTarget <a name="GraphThemeRenderingIconTarget" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget"></a>

Icon rendering target options for GraphTheme.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget.DATA">DATA</a></code> | Data icon (eg: EC2 instance type icon, T2). |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget.RESOURCE">RESOURCE</a></code> | Resource icon. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget.GENERAL">GENERAL</a></code> | General icon. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget.SERVICE">SERVICE</a></code> | Service icon. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget.CATEGORY">CATEGORY</a></code> | Category icon. |

---

##### `DATA` <a name="DATA" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget.DATA"></a>

Data icon (eg: EC2 instance type icon, T2).

Resolution precedence: `data => resource => general => service => category`

---


##### `RESOURCE` <a name="RESOURCE" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget.RESOURCE"></a>

Resource icon.

Resolution precedence: `resource => general => service => category`

---


##### `GENERAL` <a name="GENERAL" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget.GENERAL"></a>

General icon.

Resolution precedence: `resource => general => service => category`

---


##### `SERVICE` <a name="SERVICE" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget.SERVICE"></a>

Service icon.

Resolution precedence: `service => category`

---


##### `CATEGORY` <a name="CATEGORY" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget.CATEGORY"></a>

Category icon.

Resolution precedence: `category`

---

