# API Reference <a name="API Reference" id="api-reference"></a>


## Structs <a name="Structs" id="Structs"></a>

### DiagramOptions <a name="DiagramOptions" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramOptions"></a>

Options for diagrams.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramOptions.Initializer"></a>

```python
import aws_prototyping_sdk.cdk_graph_plugin_diagram

aws_prototyping_sdk.cdk_graph_plugin_diagram.DiagramOptions(
  title: str,
  preset: FilterPreset = None,
  theme: typing.Union[IGraphThemeConfigAlt, str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramOptions.property.title">title</a></code> | <code>str</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramOptions.property.preset">preset</a></code> | <code>aws_prototyping_sdk.cdk_graph.FilterPreset</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramOptions.property.theme">theme</a></code> | <code>typing.Union[<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeConfigAlt">IGraphThemeConfigAlt</a>, str]</code> | *No description.* |

---

##### `title`<sup>Required</sup> <a name="title" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramOptions.property.title"></a>

```python
title: str
```

- *Type:* str

---

##### `preset`<sup>Optional</sup> <a name="preset" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramOptions.property.preset"></a>

```python
preset: FilterPreset
```

- *Type:* aws_prototyping_sdk.cdk_graph.FilterPreset

---

##### `theme`<sup>Optional</sup> <a name="theme" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramOptions.property.theme"></a>

```python
theme: typing.Union[IGraphThemeConfigAlt, str]
```

- *Type:* typing.Union[<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeConfigAlt">IGraphThemeConfigAlt</a>, str]

---

### IDiagramConfig <a name="IDiagramConfig" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig"></a>

Diagram configuration definition.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.Initializer"></a>

```python
import aws_prototyping_sdk.cdk_graph_plugin_diagram

aws_prototyping_sdk.cdk_graph_plugin_diagram.IDiagramConfig(
  filter_plan: IGraphFilterPlan = None,
  format: typing.Union[DiagramFormat, typing.List[DiagramFormat]] = None,
  theme: typing.Union[IGraphThemeConfigAlt, str] = None,
  name: str,
  title: str,
  ignore_defaults: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.property.filterPlan">filter_plan</a></code> | <code>aws_prototyping_sdk.cdk_graph.IGraphFilterPlan</code> | Graph {@link IGraphFilterPlanFilter Plan}  used to generate a unique diagram. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.property.format">format</a></code> | <code>typing.Union[<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat">DiagramFormat</a>, typing.List[<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat">DiagramFormat</a>]]</code> | The output format(s) to generated. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.property.theme">theme</a></code> | <code>typing.Union[<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeConfigAlt">IGraphThemeConfigAlt</a>, str]</code> | Config for graph theme. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.property.name">name</a></code> | <code>str</code> | Name of the diagram. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.property.title">title</a></code> | <code>str</code> | The title of the diagram. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.property.ignoreDefaults">ignore_defaults</a></code> | <code>bool</code> | Indicates if default diagram config is applied as defaults to this config. |

---

##### `filter_plan`<sup>Optional</sup> <a name="filter_plan" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.property.filterPlan"></a>

```python
filter_plan: IGraphFilterPlan
```

- *Type:* aws_prototyping_sdk.cdk_graph.IGraphFilterPlan

Graph {@link IGraphFilterPlanFilter Plan}  used to generate a unique diagram.

---

##### `format`<sup>Optional</sup> <a name="format" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.property.format"></a>

```python
format: typing.Union[DiagramFormat, typing.List[DiagramFormat]]
```

- *Type:* typing.Union[<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat">DiagramFormat</a>, typing.List[<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat">DiagramFormat</a>]]
- *Default:* `DiagramFormat.PNG` - which will through extension also generate `DiagramFormat.SVG` and `DiagramFormat.DOT`

The output format(s) to generated.

---

##### `theme`<sup>Optional</sup> <a name="theme" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.property.theme"></a>

```python
theme: typing.Union[IGraphThemeConfigAlt, str]
```

- *Type:* typing.Union[<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeConfigAlt">IGraphThemeConfigAlt</a>, str]

Config for graph theme.

---

##### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.property.name"></a>

```python
name: str
```

- *Type:* str

Name of the diagram.

Used as the basename of the generated file(s) which gets the extension appended.

---

##### `title`<sup>Required</sup> <a name="title" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.property.title"></a>

```python
title: str
```

- *Type:* str

The title of the diagram.

---

##### `ignore_defaults`<sup>Optional</sup> <a name="ignore_defaults" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig.property.ignoreDefaults"></a>

```python
ignore_defaults: bool
```

- *Type:* bool
- *Default:* false

Indicates if default diagram config is applied as defaults to this config.

---

### IDiagramConfigBase <a name="IDiagramConfigBase" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfigBase"></a>

Base config to specific a unique diagram to be generated.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfigBase.Initializer"></a>

```python
import aws_prototyping_sdk.cdk_graph_plugin_diagram

aws_prototyping_sdk.cdk_graph_plugin_diagram.IDiagramConfigBase(
  filter_plan: IGraphFilterPlan = None,
  format: typing.Union[DiagramFormat, typing.List[DiagramFormat]] = None,
  theme: typing.Union[IGraphThemeConfigAlt, str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfigBase.property.filterPlan">filter_plan</a></code> | <code>aws_prototyping_sdk.cdk_graph.IGraphFilterPlan</code> | Graph {@link IGraphFilterPlanFilter Plan}  used to generate a unique diagram. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfigBase.property.format">format</a></code> | <code>typing.Union[<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat">DiagramFormat</a>, typing.List[<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat">DiagramFormat</a>]]</code> | The output format(s) to generated. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfigBase.property.theme">theme</a></code> | <code>typing.Union[<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeConfigAlt">IGraphThemeConfigAlt</a>, str]</code> | Config for graph theme. |

---

##### `filter_plan`<sup>Optional</sup> <a name="filter_plan" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfigBase.property.filterPlan"></a>

```python
filter_plan: IGraphFilterPlan
```

- *Type:* aws_prototyping_sdk.cdk_graph.IGraphFilterPlan

Graph {@link IGraphFilterPlanFilter Plan}  used to generate a unique diagram.

---

##### `format`<sup>Optional</sup> <a name="format" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfigBase.property.format"></a>

```python
format: typing.Union[DiagramFormat, typing.List[DiagramFormat]]
```

- *Type:* typing.Union[<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat">DiagramFormat</a>, typing.List[<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat">DiagramFormat</a>]]
- *Default:* `DiagramFormat.PNG` - which will through extension also generate `DiagramFormat.SVG` and `DiagramFormat.DOT`

The output format(s) to generated.

---

##### `theme`<sup>Optional</sup> <a name="theme" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfigBase.property.theme"></a>

```python
theme: typing.Union[IGraphThemeConfigAlt, str]
```

- *Type:* typing.Union[<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeConfigAlt">IGraphThemeConfigAlt</a>, str]

Config for graph theme.

---

### IPluginConfig <a name="IPluginConfig" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IPluginConfig"></a>

Plugin configuration for diagram plugin.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IPluginConfig.Initializer"></a>

```python
import aws_prototyping_sdk.cdk_graph_plugin_diagram

aws_prototyping_sdk.cdk_graph_plugin_diagram.IPluginConfig(
  defaults: IDiagramConfigBase = None,
  diagrams: typing.List[IDiagramConfig] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IPluginConfig.property.defaults">defaults</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfigBase">IDiagramConfigBase</a></code> | Default configuration to apply to all diagrams. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IPluginConfig.property.diagrams">diagrams</a></code> | <code>typing.List[<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig">IDiagramConfig</a>]</code> | List of diagram configurations to generate diagrams. |

---

##### `defaults`<sup>Optional</sup> <a name="defaults" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IPluginConfig.property.defaults"></a>

```python
defaults: IDiagramConfigBase
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfigBase">IDiagramConfigBase</a>

Default configuration to apply to all diagrams.

---

##### `diagrams`<sup>Optional</sup> <a name="diagrams" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IPluginConfig.property.diagrams"></a>

```python
diagrams: typing.List[IDiagramConfig]
```

- *Type:* typing.List[<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig">IDiagramConfig</a>]

List of diagram configurations to generate diagrams.

---

## Classes <a name="Classes" id="Classes"></a>

### CdkGraphDiagramPlugin <a name="CdkGraphDiagramPlugin" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin"></a>

- *Implements:* aws_prototyping_sdk.cdk_graph.ICdkGraphPlugin

CdkGraphDiagramPlugin is a {@link ICdkGraphPluginCdkGraph Plugin} implementation for generating diagram artifacts from the {@link CdkGraph} framework.

#### Initializers <a name="Initializers" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.Initializer"></a>

```python
import aws_prototyping_sdk.cdk_graph_plugin_diagram

aws_prototyping_sdk.cdk_graph_plugin_diagram.CdkGraphDiagramPlugin(
  defaults: IDiagramConfigBase = None,
  diagrams: typing.List[IDiagramConfig] = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.Initializer.parameter.defaults">defaults</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfigBase">IDiagramConfigBase</a></code> | Default configuration to apply to all diagrams. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.Initializer.parameter.diagrams">diagrams</a></code> | <code>typing.List[<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig">IDiagramConfig</a>]</code> | List of diagram configurations to generate diagrams. |

---

##### `defaults`<sup>Optional</sup> <a name="defaults" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.Initializer.parameter.defaults"></a>

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfigBase">IDiagramConfigBase</a>

Default configuration to apply to all diagrams.

---

##### `diagrams`<sup>Optional</sup> <a name="diagrams" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.Initializer.parameter.diagrams"></a>

- *Type:* typing.List[<a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IDiagramConfig">IDiagramConfig</a>]

List of diagram configurations to generate diagrams.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.getDiagramArtifact">get_diagram_artifact</a></code> | Get diagram artifact for a given name and format. |

---

##### `get_diagram_artifact` <a name="get_diagram_artifact" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.getDiagramArtifact"></a>

```python
def get_diagram_artifact(
  name: str,
  format: DiagramFormat
) -> CdkGraphArtifact
```

Get diagram artifact for a given name and format.

###### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.getDiagramArtifact.parameter.name"></a>

- *Type:* str

---

###### `format`<sup>Required</sup> <a name="format" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.getDiagramArtifact.parameter.format"></a>

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat">DiagramFormat</a>

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.artifactFilename">artifact_filename</a></code> | Get standardized artifact file name for diagram artifacts. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.artifactId">artifact_id</a></code> | Get standardized artifact id for diagram artifacts. |

---

##### `artifact_filename` <a name="artifact_filename" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.artifactFilename"></a>

```python
import aws_prototyping_sdk.cdk_graph_plugin_diagram

aws_prototyping_sdk.cdk_graph_plugin_diagram.CdkGraphDiagramPlugin.artifact_filename(
  name: str,
  format: DiagramFormat
)
```

Get standardized artifact file name for diagram artifacts.

###### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.artifactFilename.parameter.name"></a>

- *Type:* str

---

###### `format`<sup>Required</sup> <a name="format" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.artifactFilename.parameter.format"></a>

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat">DiagramFormat</a>

---

##### `artifact_id` <a name="artifact_id" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.artifactId"></a>

```python
import aws_prototyping_sdk.cdk_graph_plugin_diagram

aws_prototyping_sdk.cdk_graph_plugin_diagram.CdkGraphDiagramPlugin.artifact_id(
  name: str,
  format: DiagramFormat
)
```

Get standardized artifact id for diagram artifacts.

###### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.artifactId.parameter.name"></a>

- *Type:* str

---

###### `format`<sup>Required</sup> <a name="format" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.artifactId.parameter.format"></a>

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat">DiagramFormat</a>

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.config">config</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IPluginConfig">IPluginConfig</a></code> | Get diagram plugin config. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.id">id</a></code> | <code>str</code> | Unique identifier for this plugin. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.version">version</a></code> | <code>str</code> | Plugin version. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.defaultDotArtifact">default_dot_artifact</a></code> | <code>aws_prototyping_sdk.cdk_graph.CdkGraphArtifact</code> | Get default dot artifact. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.defaultPngArtifact">default_png_artifact</a></code> | <code>aws_prototyping_sdk.cdk_graph.CdkGraphArtifact</code> | Get default PNG artifact. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.dependencies">dependencies</a></code> | <code>typing.List[str]</code> | List of plugins this plugin depends on, including optional semver version (eg: ["foo", "bar@1.2"]). |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.bind">bind</a></code> | <code>aws_prototyping_sdk.cdk_graph.IGraphPluginBindCallback</code> | Binds the plugin to the CdkGraph instance. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.report">report</a></code> | <code>aws_prototyping_sdk.cdk_graph.IGraphReportCallback</code> | Generate asynchronous reports based on the graph. |

---

##### `config`<sup>Required</sup> <a name="config" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.config"></a>

```python
config: IPluginConfig
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IPluginConfig">IPluginConfig</a>

Get diagram plugin config.

---

##### `id`<sup>Required</sup> <a name="id" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.id"></a>

```python
id: str
```

- *Type:* str

Unique identifier for this plugin.

---

##### `version`<sup>Required</sup> <a name="version" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.version"></a>

```python
version: str
```

- *Type:* str

Plugin version.

---

##### `default_dot_artifact`<sup>Optional</sup> <a name="default_dot_artifact" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.defaultDotArtifact"></a>

```python
default_dot_artifact: CdkGraphArtifact
```

- *Type:* aws_prototyping_sdk.cdk_graph.CdkGraphArtifact

Get default dot artifact.

---

##### `default_png_artifact`<sup>Optional</sup> <a name="default_png_artifact" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.defaultPngArtifact"></a>

```python
default_png_artifact: CdkGraphArtifact
```

- *Type:* aws_prototyping_sdk.cdk_graph.CdkGraphArtifact

Get default PNG artifact.

---

##### `dependencies`<sup>Optional</sup> <a name="dependencies" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.dependencies"></a>

```python
dependencies: typing.List[str]
```

- *Type:* typing.List[str]

List of plugins this plugin depends on, including optional semver version (eg: ["foo", "bar@1.2"]).

---

##### `bind`<sup>Required</sup> <a name="bind" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.bind"></a>

```python
bind: IGraphPluginBindCallback
```

- *Type:* aws_prototyping_sdk.cdk_graph.IGraphPluginBindCallback

Binds the plugin to the CdkGraph instance.

Enables plugins to receive base configs.

---

##### `report`<sup>Optional</sup> <a name="report" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.report"></a>

```python
report: IGraphReportCallback
```

- *Type:* aws_prototyping_sdk.cdk_graph.IGraphReportCallback

Generate asynchronous reports based on the graph.

This is not automatically called when synthesizing CDK.
Developer must explicitly add `await graphInstance.report()` to the CDK bin or invoke this outside
of the CDK synth. In either case, the plugin receives the in-memory graph interface when invoked, as the
CdkGraph will deserialize the graph prior to invoking the plugin report.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.ARTIFACT_NS">ARTIFACT_NS</a></code> | <code>str</code> | Namespace for artifacts of the diagram plugin. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.ID">ID</a></code> | <code>str</code> | Fixed id of the diagram plugin. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.VERSION">VERSION</a></code> | <code>str</code> | Current semantic version of the diagram plugin. |

---

##### `ARTIFACT_NS`<sup>Required</sup> <a name="ARTIFACT_NS" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.ARTIFACT_NS"></a>

```python
ARTIFACT_NS: str
```

- *Type:* str

Namespace for artifacts of the diagram plugin.

---

##### `ID`<sup>Required</sup> <a name="ID" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.ID"></a>

```python
ID: str
```

- *Type:* str

Fixed id of the diagram plugin.

---

##### `VERSION`<sup>Required</sup> <a name="VERSION" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.CdkGraphDiagramPlugin.property.VERSION"></a>

```python
VERSION: str
```

- *Type:* str

Current semantic version of the diagram plugin.

---

## Protocols <a name="Protocols" id="Protocols"></a>

### IGraphThemeConfigAlt <a name="IGraphThemeConfigAlt" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeConfigAlt"></a>

- *Implemented By:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeConfigAlt">IGraphThemeConfigAlt</a>

GraphThemeConfigAlt is simplified definition of theme to apply.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeConfigAlt.property.rendering">rendering</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering">IGraphThemeRendering</a></code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeConfigAlt.property.theme">theme</a></code> | <code>str</code> | *No description.* |

---

##### `rendering`<sup>Optional</sup> <a name="rendering" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeConfigAlt.property.rendering"></a>

```python
rendering: IGraphThemeRendering
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering">IGraphThemeRendering</a>

---

##### `theme`<sup>Optional</sup> <a name="theme" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeConfigAlt.property.theme"></a>

```python
theme: str
```

- *Type:* str

---

### IGraphThemeRendering <a name="IGraphThemeRendering" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering"></a>

- *Extends:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingIconProps">IGraphThemeRenderingIconProps</a>, <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingOptions">IGraphThemeRenderingOptions</a>

- *Implemented By:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering">IGraphThemeRendering</a>

Properties for defining the rendering options for the graph theme.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.cfnResourceIconMax">cfn_resource_icon_max</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a></code> | Highest Graph.CfnResourceNode icon to render. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.cfnResourceIconMin">cfn_resource_icon_min</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a></code> | Lowest Graph.CfnResourceNode icon to render. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.resourceIconMax">resource_icon_max</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a></code> | Highest Graph.ResourceNode icon to render. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.resourceIconMin">resource_icon_min</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a></code> | Lowest Graph.ResourceNode icon to render. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.layout">layout</a></code> | <code>str</code> | Layout direction of the graph. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.stack">stack</a></code> | <code>str</code> | Specify regex pattern to match root stacks to render. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.stage">stage</a></code> | <code>str</code> | Specify which stage to render when multiple stages are available. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.unconstrainedCrossClusterEdges">unconstrained_cross_cluster_edges</a></code> | <code>bool</code> | Prevent cross-cluster edges from ranking nodes in layout. |

---

##### `cfn_resource_icon_max`<sup>Optional</sup> <a name="cfn_resource_icon_max" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.cfnResourceIconMax"></a>

```python
cfn_resource_icon_max: GraphThemeRenderingIconTarget
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a>

Highest Graph.CfnResourceNode icon to render.

---

##### `cfn_resource_icon_min`<sup>Optional</sup> <a name="cfn_resource_icon_min" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.cfnResourceIconMin"></a>

```python
cfn_resource_icon_min: GraphThemeRenderingIconTarget
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a>

Lowest Graph.CfnResourceNode icon to render.

---

##### `resource_icon_max`<sup>Optional</sup> <a name="resource_icon_max" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.resourceIconMax"></a>

```python
resource_icon_max: GraphThemeRenderingIconTarget
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a>

Highest Graph.ResourceNode icon to render.

---

##### `resource_icon_min`<sup>Optional</sup> <a name="resource_icon_min" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.resourceIconMin"></a>

```python
resource_icon_min: GraphThemeRenderingIconTarget
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a>

Lowest Graph.ResourceNode icon to render.

---

##### `layout`<sup>Optional</sup> <a name="layout" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.layout"></a>

```python
layout: str
```

- *Type:* str
- *Default:* horizontal

Layout direction of the graph.

---

##### `stack`<sup>Optional</sup> <a name="stack" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.stack"></a>

```python
stack: str
```

- *Type:* str
- *Default:* undefined Will render all stacks

Specify regex pattern to match root stacks to render.

---

##### `stage`<sup>Optional</sup> <a name="stage" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.stage"></a>

```python
stage: str
```

- *Type:* str
- *Default:* last

Specify which stage to render when multiple stages are available.

Can be a preset value of "first", "last", and "all", or regex string of the stage(s) to render.

---

##### `unconstrained_cross_cluster_edges`<sup>Optional</sup> <a name="unconstrained_cross_cluster_edges" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering.property.unconstrainedCrossClusterEdges"></a>

```python
unconstrained_cross_cluster_edges: bool
```

- *Type:* bool
- *Default:* false

Prevent cross-cluster edges from ranking nodes in layout.

> [https://graphviz.org/docs/attrs/constraint/](https://graphviz.org/docs/attrs/constraint/)

---

### IGraphThemeRenderingIconProps <a name="IGraphThemeRenderingIconProps" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingIconProps"></a>

- *Implemented By:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering">IGraphThemeRendering</a>, <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingIconProps">IGraphThemeRenderingIconProps</a>

Icon specific properties for configuring graph rendering of resource icons.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingIconProps.property.cfnResourceIconMax">cfn_resource_icon_max</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a></code> | Highest Graph.CfnResourceNode icon to render. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingIconProps.property.cfnResourceIconMin">cfn_resource_icon_min</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a></code> | Lowest Graph.CfnResourceNode icon to render. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingIconProps.property.resourceIconMax">resource_icon_max</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a></code> | Highest Graph.ResourceNode icon to render. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingIconProps.property.resourceIconMin">resource_icon_min</a></code> | <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a></code> | Lowest Graph.ResourceNode icon to render. |

---

##### `cfn_resource_icon_max`<sup>Optional</sup> <a name="cfn_resource_icon_max" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingIconProps.property.cfnResourceIconMax"></a>

```python
cfn_resource_icon_max: GraphThemeRenderingIconTarget
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a>

Highest Graph.CfnResourceNode icon to render.

---

##### `cfn_resource_icon_min`<sup>Optional</sup> <a name="cfn_resource_icon_min" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingIconProps.property.cfnResourceIconMin"></a>

```python
cfn_resource_icon_min: GraphThemeRenderingIconTarget
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a>

Lowest Graph.CfnResourceNode icon to render.

---

##### `resource_icon_max`<sup>Optional</sup> <a name="resource_icon_max" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingIconProps.property.resourceIconMax"></a>

```python
resource_icon_max: GraphThemeRenderingIconTarget
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a>

Highest Graph.ResourceNode icon to render.

---

##### `resource_icon_min`<sup>Optional</sup> <a name="resource_icon_min" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingIconProps.property.resourceIconMin"></a>

```python
resource_icon_min: GraphThemeRenderingIconTarget
```

- *Type:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget">GraphThemeRenderingIconTarget</a>

Lowest Graph.ResourceNode icon to render.

---

### IGraphThemeRenderingOptions <a name="IGraphThemeRenderingOptions" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingOptions"></a>

- *Implemented By:* <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRendering">IGraphThemeRendering</a>, <a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingOptions">IGraphThemeRenderingOptions</a>

Additional graph rendering options.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingOptions.property.layout">layout</a></code> | <code>str</code> | Layout direction of the graph. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingOptions.property.stack">stack</a></code> | <code>str</code> | Specify regex pattern to match root stacks to render. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingOptions.property.stage">stage</a></code> | <code>str</code> | Specify which stage to render when multiple stages are available. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingOptions.property.unconstrainedCrossClusterEdges">unconstrained_cross_cluster_edges</a></code> | <code>bool</code> | Prevent cross-cluster edges from ranking nodes in layout. |

---

##### `layout`<sup>Optional</sup> <a name="layout" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingOptions.property.layout"></a>

```python
layout: str
```

- *Type:* str
- *Default:* horizontal

Layout direction of the graph.

---

##### `stack`<sup>Optional</sup> <a name="stack" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingOptions.property.stack"></a>

```python
stack: str
```

- *Type:* str
- *Default:* undefined Will render all stacks

Specify regex pattern to match root stacks to render.

---

##### `stage`<sup>Optional</sup> <a name="stage" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingOptions.property.stage"></a>

```python
stage: str
```

- *Type:* str
- *Default:* last

Specify which stage to render when multiple stages are available.

Can be a preset value of "first", "last", and "all", or regex string of the stage(s) to render.

---

##### `unconstrained_cross_cluster_edges`<sup>Optional</sup> <a name="unconstrained_cross_cluster_edges" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.IGraphThemeRenderingOptions.property.unconstrainedCrossClusterEdges"></a>

```python
unconstrained_cross_cluster_edges: bool
```

- *Type:* bool
- *Default:* false

Prevent cross-cluster edges from ranking nodes in layout.

> [https://graphviz.org/docs/attrs/constraint/](https://graphviz.org/docs/attrs/constraint/)

---

## Enums <a name="Enums" id="Enums"></a>

### DiagramFormat <a name="DiagramFormat" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat"></a>

Supported diagram formats that can be generated.

Extended formats are automatically generated, for example if you generate "png" which extends
"svg" which extends "dot", the resulting generated files will be all aforementioned.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat.DOT">DOT</a></code> | Graphviz [DOT Language](https://graphviz.org/doc/info/lang.html). |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat.SVG">SVG</a></code> | [SVG](https://developer.mozilla.org/en-US/docs/Web/SVG) generated using [dot-wasm](https://hpcc-systems.github.io/hpcc-js-wasm/classes/graphviz.Graphviz.html) from {@link DiagramFormat.DOT} file. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat.PNG">PNG</a></code> | [PNG](https://en.wikipedia.org/wiki/Portable_Network_Graphics) generated using [sharp](https://sharp.pixelplumbing.com/api-output#png) from {@link DiagramFormat.SVG} file. |

---

##### `DOT` <a name="DOT" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat.DOT"></a>

Graphviz [DOT Language](https://graphviz.org/doc/info/lang.html).

---


##### `SVG` <a name="SVG" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat.SVG"></a>

[SVG](https://developer.mozilla.org/en-US/docs/Web/SVG) generated using [dot-wasm](https://hpcc-systems.github.io/hpcc-js-wasm/classes/graphviz.Graphviz.html) from {@link DiagramFormat.DOT} file.

---


##### `PNG` <a name="PNG" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.DiagramFormat.PNG"></a>

[PNG](https://en.wikipedia.org/wiki/Portable_Network_Graphics) generated using [sharp](https://sharp.pixelplumbing.com/api-output#png) from {@link DiagramFormat.SVG} file.

---


### GraphThemeRenderingIconTarget <a name="GraphThemeRenderingIconTarget" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget"></a>

Icon rendering target options for GraphTheme.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget.DATA">DATA</a></code> | Data icon (eg: EC2 instance type icon, T2). |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget.RESOURCE">RESOURCE</a></code> | Resource icon. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget.GENERAL">GENERAL</a></code> | General icon. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget.SERVICE">SERVICE</a></code> | Service icon. |
| <code><a href="#@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget.CATEGORY">CATEGORY</a></code> | Category icon. |

---

##### `DATA` <a name="DATA" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget.DATA"></a>

Data icon (eg: EC2 instance type icon, T2).

Resolution precedence: `data => resource => general => service => category`

---


##### `RESOURCE` <a name="RESOURCE" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget.RESOURCE"></a>

Resource icon.

Resolution precedence: `resource => general => service => category`

---


##### `GENERAL` <a name="GENERAL" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget.GENERAL"></a>

General icon.

Resolution precedence: `resource => general => service => category`

---


##### `SERVICE` <a name="SERVICE" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget.SERVICE"></a>

Service icon.

Resolution precedence: `service => category`

---


##### `CATEGORY` <a name="CATEGORY" id="@aws-prototyping-sdk/cdk-graph-plugin-diagram.GraphThemeRenderingIconTarget.CATEGORY"></a>

Category icon.

Resolution precedence: `category`

---

